// ****** Mixer audio v2 ********

// CONSOLE versione con versioni tenute allineate derivata da v2_r1_02
/*
Keywords : https://github.com/sumotoy/OLED_pictivaWide/blob/master/keywords.txt
Fonts :    https://github.com/sumotoy/OLED_pictivaWide/tree/master/_fonts
*/
#include <SPI.h>
#include <OLED_pictivaWide.h>
#include "_fonts/arial_x3.c"//check the _font folder for more fonts!
#include "_fonts/arial_x1.c"//check the _font folder for more fonts!
#include "_fonts/arial_x4.c"//check the _font folder for more fonts!
#include <Wire.h>

#include <Arduino.h>
#include <DebounceEvent.h>

// Definizione variabili
String RadioInput1="FTM 400";
String RadioInput2="FTM 400";
String RadioInput3="FTM 100";
String RadioInput4="#######";
String RadioInput5="IC 7610";

String TextInput1= "  Vfo  A ";
String TextInput2= "  Vfo  B ";
String TextInput3= "";
String TextInput4= "";
String TextInput5= "SUB Rx";

String curr_release = "Prod_10";

uint8_t barColor = 0xFF;
uint8_t barBlack = 0x00;

int Audio_1_Mute_On=1; // inizializzate a 1 altrimenti al boot sono in Mute
int Audio_2_Mute_On=1;
int Audio_3_Mute_On=1;
int Audio_4_Mute_On=1;
int Audio_5_Mute_On=1;
int Audio_Mute_All=0; // tutti MUTE al boot

// definizione delle variabili che riceveranno i livelli dai pin analogici che si trovano sul Main ma trasmessi alla console via I2C con lo stesso nome di variabile
// int Audio_1 = A1;
uint8_t ValAudio_1 = 0;
// int Audio_2 = A2;
uint8_t ValAudio_2 = 0;
// int Audio_3 = A3;
uint8_t ValAudio_3 = 0;
// int Audio_4 = A4;
uint8_t ValAudio_4 = 0;
// int Audio_5 = A5;
uint8_t ValAudio_5 = 0;

// definizione della variabile che contiene il valore del potenziometro di Volume che verrà passata al Main per regolare il potenziometro digitale
// *** int MasterVolume = A0;        // pin A0 al quale è connesso il potenziometro
uint8_t ValMasterVolume = 0;  // ex 0 valore letto dal potenziometro
uint8_t VolBar = 0;           // variabile per adattare l'altezza della barra del volume
uint8_t VolBarBottom = 0;            // inverso del nr letto sul potenziometro per far partire la barra dal basso

// definizione input digitali collegati ai pulsanti di Mute
const int Audio_1_Mute = 4; // era 2 pin al quale è connesso il pulsante di Mute del canale audio
const int Audio_2_Mute = 5; // era 3 pin al quale è connesso il pulsante di Mute del canale audio
const int Audio_3_Mute = 6; // pin al quale è connesso il pulsante di Mute del canale audio
const int Audio_4_Mute = 7; // pin al quale è connesso il pulsante di Mute del canale audio
const int Audio_5_Mute = 12; // pin al quale è connesso il pulsante di Mute del canale audio
const int Audio_All = 0; // era 7 pin al quale è connesso il pulsante di Mute di tutti i canali audio

// definizione variabili per encoder
int encoderPin1 = 2;
int encoderPin2 = 3;
 
volatile int lastEncoded = 0;
volatile long encoderValue = 30; // ex 0 ex 80 PreSetta valore encoder e quindi volume al boot
 
long lastencoderValue = 0;
 
int lastMSB = 0;
int lastLSB = 0;
// -----------------------------------

// settaggio tempi di debounce dei 5 pulsanti
#define CUSTOM_DEBOUNCE_DELAY   3 // ex50
#define CUSTOM_REPEAT_DELAY     2 // ex 500
DebounceEvent * button1;
DebounceEvent * button2;
DebounceEvent * button3;
DebounceEvent * button4;
DebounceEvent * button5;
DebounceEvent * button6;

// definizione display con Pin giusti
#define RST_PIN   8
#define DC_PIN    9 // ex 23
#define CS_PIN    10 // ex 10

OLED_pictivaWide oled = OLED_pictivaWide(CS_PIN, DC_PIN, RST_PIN);;

// ******inizio ciclo Setup ********
void setup() {

// *** analogRead(MasterVolume); // prima lettura del potenziometro
// encoder
pinMode(encoderPin1, INPUT);
  pinMode(encoderPin2, INPUT);
  // pinMode(ledPin1, OUTPUT); // tolto
 
  digitalWrite(encoderPin1, HIGH); //turn pullup resistor on
  digitalWrite(encoderPin2, HIGH); //turn pullup resistor on
  // analogWrite (ledPin1,LOW); // tolto
 
  attachInterrupt(0, updateEncoder, CHANGE);
  attachInterrupt(1, updateEncoder, CHANGE);
// -------

  Serial.begin(9600);
  // ----------- inizializzazione colloquio bus I2C con ID 9
  Wire.begin(9);
  TWBR = 32; // http://www.gammon.com.au/i2c setto I2C a 200 KHz
  
  oled.begin();

// inizializzazione input digitali
  pinMode(Audio_1_Mute, INPUT_PULLUP);
  pinMode(Audio_2_Mute, INPUT_PULLUP);
  pinMode(Audio_3_Mute, INPUT_PULLUP);
  pinMode(Audio_4_Mute, INPUT_PULLUP);
  pinMode(Audio_5_Mute, INPUT_PULLUP);
  pinMode(Audio_All, INPUT_PULLUP);

// Welcome screen
oled.setCursor(5, 1);
oled.print("Release sketch:"+curr_release);
delay(2000);
// Fine welcome screen

// Maschera di lavoro
// Prima riga nomi delle radio
oled.clearScreen(); 
oled.setFont(&arial_x1);
oled.setCursor(0, 0);
oled.print(RadioInput1);
oled.setCursor(7, 0);
oled.print(RadioInput2);
oled.setCursor(14, 0);
oled.print(RadioInput3);
oled.setCursor(20, 0);
oled.print(RadioInput4);
oled.setCursor(27, 0);
oled.print(RadioInput5);

// oled.setFont(&arial_x1);
// Seconda riga eventuali ulteriori info
oled.setCursor(0, 2);
oled.print(TextInput1);
oled.setCursor(7, 2);
oled.print(TextInput2);
oled.setCursor(14, 2);
oled.print(TextInput3);
oled.setCursor(20, 2);
oled.print(TextInput4);
oled.setCursor(27, 2);
oled.print(TextInput5);

// Messa sotto debounce dei 5 pulsanti di Mute
button1 = new DebounceEvent(Audio_1_Mute, BUTTON_PUSHBUTTON | BUTTON_DEFAULT_HIGH | BUTTON_SET_PULLUP, CUSTOM_DEBOUNCE_DELAY, CUSTOM_REPEAT_DELAY);
button2 = new DebounceEvent(Audio_2_Mute, BUTTON_PUSHBUTTON | BUTTON_DEFAULT_HIGH | BUTTON_SET_PULLUP, CUSTOM_DEBOUNCE_DELAY, CUSTOM_REPEAT_DELAY);
button3 = new DebounceEvent(Audio_3_Mute, BUTTON_PUSHBUTTON | BUTTON_DEFAULT_HIGH | BUTTON_SET_PULLUP, CUSTOM_DEBOUNCE_DELAY, CUSTOM_REPEAT_DELAY);
button4 = new DebounceEvent(Audio_4_Mute, BUTTON_PUSHBUTTON | BUTTON_DEFAULT_HIGH | BUTTON_SET_PULLUP, CUSTOM_DEBOUNCE_DELAY, CUSTOM_REPEAT_DELAY);
button5 = new DebounceEvent(Audio_5_Mute, BUTTON_PUSHBUTTON | BUTTON_DEFAULT_HIGH | BUTTON_SET_PULLUP, CUSTOM_DEBOUNCE_DELAY, CUSTOM_REPEAT_DELAY);
button6 = new DebounceEvent(Audio_Mute_All, BUTTON_PUSHBUTTON | BUTTON_DEFAULT_HIGH | BUTTON_SET_PULLUP, CUSTOM_DEBOUNCE_DELAY, CUSTOM_REPEAT_DELAY);
    
} // *********** fine ciclo Setup **********


// ************* inizio ciclo Loop ************
void loop() {

// encoder
  if ( encoderValue > 255 ) { encoderValue = 255; }
  if ( encoderValue < 0 )   { encoderValue = 0; }
// --------

// gestione del potenziometro del volume
// *** ValMasterVolume = analogRead(MasterVolume)/4; // conversione da 1023 a 255
// *** VolBar = ValMasterVolume/5.5; // conversione da 255 a 45 righe verticali max del display

ValMasterVolume = encoderValue/4;
VolBar = encoderValue/5.5;
VolBarBottom=47-VolBar;       // inversione del valore per originare la barra dal basso quando è 0->47 quando è 47->0


// stampa su monitor seriale dei valori attuali
  Serial.println("Valore dell'encoder");
  Serial.println(encoderValue);
  //Serial.println(VolBarBottom);
  Serial.println(Audio_Mute_All);

// lettura dei pulsanti di messa in Mute in modo bistabile. La riga var = !val inverte lo stato a prescindere di come fosse
  //Audio_1_Mute_On=digitalRead(Audio_1_Mute);
//------------------------------------------
if (unsigned int event = button1->loop()) {
        if (event == EVENT_PRESSED) {   
            Audio_1_Mute_On = !Audio_1_Mute_On;
        }        
    }
//------------------------------------------  
  //Audio_2_Mute_On=digitalRead(Audio_2_Mute);
//------------------------------------------
if (unsigned int event = button2->loop()) {
        if (event == EVENT_PRESSED) {   
            Audio_2_Mute_On = !Audio_2_Mute_On;
        }        
    }
//------------------------------------------
  //Audio_3_Mute_On=digitalRead(Audio_3_Mute);
//------------------------------------------
if (unsigned int event = button3->loop()) {
        if (event == EVENT_PRESSED) {   
            Audio_3_Mute_On = !Audio_3_Mute_On;
        }        
    }
//------------------------------------------
  //Audio_4_Mute_On=digitalRead(Audio_4_Mute);
//------------------------------------------
if (unsigned int event = button4->loop()) {
        if (event == EVENT_PRESSED) {   
            Audio_4_Mute_On = !Audio_4_Mute_On;
        }        
    }
//------------------------------------------  
  //Audio_5_Mute_On=digitalRead(Audio_5_Mute);
//------------------------------------------
if (unsigned int event = button5->loop()) {
        if (event == EVENT_PRESSED) {   
            Audio_5_Mute_On = !Audio_5_Mute_On;
        }        
    }
//------------------------------------------
// lettura dell'interruttore di Mute All  
  //Audio_Mute_All=digitalRead(Audio_All);
if (unsigned int event = button6->loop()) {
        if (event == EVENT_PRESSED) {   
            Audio_Mute_All = !Audio_Mute_All;
        }        
    }
//------------------------------------------
  
  // scambio dati via i2c
  Wire.beginTransmission(8); // transmit to device #8
  Wire.write(Audio_1_Mute_On);   
  Wire.write(Audio_2_Mute_On); 
  Wire.write(Audio_3_Mute_On);   
  Wire.write(Audio_4_Mute_On);  
  Wire.write(Audio_5_Mute_On);
  Wire.write(Audio_Mute_All);  
  Wire.write(ValMasterVolume);  
  Wire.endTransmission();    // stop transmitting

delay(20); // aggiunta
  
  // ricezione del valore dei livelli VU dal main
  Wire.onReceive(receiveEvent);
  
  // delay(10); // ex 500 TOLTO
  
  reset_bars();       // pulizia delle barre
  draw_bars();        // aggiorna barre
  draw_Mute_status(); // aggiorna stato degli interruttori di Mute
  
} // ********** fine ciclo Loop *************

// *********** Funzioni di servizio *********

// ****************************
void reset_bars(void) {

  // pulisce tutte le barre per poterle ridisegnare col nuovo valore
  oled.drawLine(0,44,100,44,barBlack); // 100 era 40
  oled.drawLine(0,45,100,45,barBlack);
  oled.drawLine(0,46,100,46,barBlack);
  oled.drawLine(0,47,100,47,barBlack);

/*
 righe OK
  oled.drawFastVLine(350,1,47,barBlack);
  oled.drawFastVLine(351,1,47,barBlack);
*/
  
  oled.drawFastVLine(350,1,47,barBlack);
  oled.drawFastVLine(351,1,47,barBlack);  
}
// ****************************
void draw_bars(void) {

// Stampa delle barre orizzontali VU
oled.drawFastHLine(0,44,ValAudio_1,44,barColor,40);
oled.drawFastHLine(0,45,ValAudio_1,45,barColor,40);
oled.drawFastHLine(0,46,ValAudio_1,46,barColor,40);
oled.drawFastHLine(0,47,ValAudio_1,47,barColor,40);

oled.drawFastHLine(58,44,ValAudio_2,44,barColor,40);
oled.drawFastHLine(58,45,ValAudio_2,45,barColor,40);
oled.drawFastHLine(58,46,ValAudio_2,46,barColor,40);
oled.drawFastHLine(58,47,ValAudio_2,47,barColor,40);

oled.drawFastHLine(120,44,ValAudio_3,44,barColor,40);
oled.drawFastHLine(120,45,ValAudio_3,45,barColor,40);
oled.drawFastHLine(120,46,ValAudio_3,46,barColor,40);
oled.drawFastHLine(120,47,ValAudio_3,47,barColor,40);

oled.drawFastHLine(178,44,ValAudio_4,44,barColor,40);
oled.drawFastHLine(178,45,ValAudio_4,45,barColor,40);
oled.drawFastHLine(178,46,ValAudio_4,46,barColor,40);
oled.drawFastHLine(178,47,ValAudio_4,47,barColor,40);

oled.drawFastHLine(242,44,ValAudio_5,44,barColor,40); // era 245
oled.drawFastHLine(242,45,ValAudio_5,45,barColor,40);
oled.drawFastHLine(242,46,ValAudio_5,46,barColor,40);
oled.drawFastHLine(242,47,ValAudio_5,47,barColor,40);

// Stampa barra verticale volume
/*
Righe OK
oled.drawFastVLine(350,1,VolBar,barColor);
oled.drawFastVLine(351,1,VolBar,barColor);
*/

// oled.drawRect(282,1,4,VolBar,barColor,0); // riga OK

oled.drawRect(282,VolBarBottom,4,VolBar,barColor,40); // PERFETTO !!!!!!!

}

// ****************************
void draw_Mute_status(void) {

if (Audio_Mute_All==0) {  
  oled.setFont(&arial_x4);
  oled.setCursor(1, 2);
  oled.print("                                   All MUTED                                ");
  delay(300);
 // pulisce schermo da messaggio all muted
  oled.drawLine(0,26,200,26,barBlack);
  oled.drawLine(0,27,200,27,barBlack);
  oled.drawLine(0,28,200,28,barBlack);
  oled.drawLine(0,29,200,29,barBlack);
  oled.drawLine(0,30,200,30,barBlack);
  oled.drawLine(0,31,200,31,barBlack);
  oled.drawLine(0,32,200,32,barBlack);
  oled.drawLine(0,33,200,33,barBlack);
  oled.drawLine(0,34,200,34,barBlack);
  oled.drawLine(0,35,200,35,barBlack); 
 
}
else
{

// verfica se è stato messo in Mute qualche canale

if (Audio_1_Mute_On==1) {
  oled.setFont(&arial_x4);
  oled.setCursor(1, 2); // ex 1,2
  oled.print("O N");       
}
else
{
  oled.setFont(&arial_x4);
  oled.setCursor(1, 2);
  oled.print("Off");  
} 
// -------------------------
if (Audio_2_Mute_On==1) {
  oled.setFont(&arial_x4);
  oled.setCursor(8, 2);
  oled.print("O N");
}
else
{
  oled.setFont(&arial_x4);
  oled.setCursor(8, 2);
  oled.print("Off");  
} 
// --------------------------
if (Audio_3_Mute_On==1) {
  oled.setFont(&arial_x4);
  oled.setCursor(15, 2);
  oled.print("O N");
}
else
{
  oled.setFont(&arial_x4);
  oled.setCursor(15, 2);
  oled.print("Off");  
} 
// --------------------------
if (Audio_4_Mute_On==1) {
  oled.setFont(&arial_x4);
  oled.setCursor(21, 2);
  oled.print("O N");
}
else
{
  oled.setFont(&arial_x4);
  oled.setCursor(21, 2);
  oled.print("Off");  
} 
// --------------------------
if (Audio_5_Mute_On==1) {
  oled.setFont(&arial_x4);
  oled.setCursor(28, 2);
  oled.print("O N");
}
else
{
  oled.setFont(&arial_x4);
  oled.setCursor(28, 2);
  oled.print("Off");  
} 

} // fine all muted

}
// ****************************
void draw_mask(void) {
// Maschera di lavoro
// Prima riga nomi delle radio
oled.clearScreen(); 
oled.setFont(&arial_x1);
oled.setCursor(0, 0);
oled.print(RadioInput1);
oled.setCursor(7, 0);
oled.print(RadioInput2);
oled.setCursor(14, 0);
oled.print(RadioInput3);

//oled.setFontColor(dimContrast);
oled.setCursor(20, 0);
oled.print(RadioInput4);
//oled.setFontColor(fullContrast);

oled.setCursor(28, 0);
oled.print(RadioInput5);

// Seconda riga eventuali ulteriori info
oled.setCursor(0, 2);
oled.print(TextInput1);
oled.setCursor(7, 2);
oled.print(TextInput2);
oled.setCursor(14, 2);
oled.print(TextInput3);
oled.setCursor(20, 2);
oled.print(TextInput4);
oled.setCursor(28, 2);
oled.print(TextInput5);
}

// *********** Funzioni di servizio *********

void receiveEvent(int bytes) {

  // ricezione dello stato degli interruttori Mute della console
  ValAudio_1 = Wire.read();      
  ValAudio_2 = Wire.read();    
  ValAudio_3 = Wire.read();      
  ValAudio_4 = Wire.read();    
  ValAudio_5 = Wire.read();    

  // delay(10); // ex 500 TOLTO
}
// --------------------------------------------
void updateEncoder(){
  int MSB = digitalRead(encoderPin1); //MSB = most significant bit
  int LSB = digitalRead(encoderPin2); //LSB = least significant bit
 
  int encoded = (MSB << 1) |LSB; //converting the 2 pin value to single number
  int sum  = (lastEncoded << 2) | encoded; //adding it to the previous encoded value
 
  if(sum == 0b1101 || sum == 0b0100 || sum == 0b0010 || sum == 0b1011) encoderValue ++;
  if(sum == 0b1110 || sum == 0b0111 || sum == 0b0001 || sum == 0b1000) encoderValue --;
 
  lastEncoded = encoded; //store this value for next time
}
