// ****** Mixer audio v2 ********

// MAIN versione con versioni tenute allineate derivata da v2_r1_02


#include <Wire.h>
#include <SPI.h> 

const int CS = 10; // pin 10 comando pot digitale aggiunta

int Audio_1_Mute_On=0;
int Audio_2_Mute_On=0;
int Audio_3_Mute_On=0;
int Audio_4_Mute_On=0;
int Audio_5_Mute_On=0;
int Audio_Mute_All=1; // inizializzata a 1 perchè 0 = tutti MUTE quindi colpo di relè al boot


// uint8_t dimContrast = 0x20; // contrasto basso
// uint8_t fullContrast = 0xFF; // contrasto basso

// definizione degli input analogici - A4 e A5 occupati per colloquio i2c
int Audio_1 = A1;
uint8_t ValAudio_1 = 0;
int Audio_2 = A2;
uint8_t ValAudio_2 = 0;
int Audio_3 = A3;
uint8_t ValAudio_3 = 0;
int Audio_4 = A6;
uint8_t ValAudio_4 = 0;
int Audio_5 = A7;
uint8_t ValAudio_5 = 0;

uint8_t ValMasterVolume = 0;  // valore letto dal potenziometro

// definizione input digitali collegati agli interruttori di Mute
const int Audio_1_Mute = 2; // pin al quale è connesso il relè di Mute del canale audio 1
const int Audio_2_Mute = 3; // pin al quale è connesso il relè di Mute del canale audio 2
const int Audio_3_Mute = 4; // pin al quale è connesso il relè di Mute del canale audio 3
const int Audio_4_Mute = 5; // pin al quale è connesso il relè di Mute del canale audio 4
const int Audio_5_Mute = 6; // pin al quale è connesso il relè di Mute del canale audio 5

// ******inizio ciclo Setup ********
void setup() {
  
/*
  Serial.begin(38400);
  long unsigned debug_start = millis ();
  while (!Serial && ((millis () - debug_start) <= 5000)) ;
  Serial.println("started");
  oled.begin();
*/
// inizializzazione pin 10 comando pot digitale
  pinMode (CS, OUTPUT); // aggiunta
  SPI.begin();          // aggiunta 

// prima lettura degli ingressi analogici SOLO PER TEST
  analogRead(Audio_1); 
  analogRead(Audio_2);
  analogRead(Audio_3); 
  analogRead(Audio_4);
  analogRead(Audio_5);

// inizializzazione input digitali
  pinMode(Audio_1_Mute, OUTPUT);
  pinMode(Audio_2_Mute, OUTPUT);
  pinMode(Audio_3_Mute, OUTPUT);
  pinMode(Audio_4_Mute, OUTPUT);
  pinMode(Audio_5_Mute, OUTPUT);

  Serial.begin(9600);
  // Serial.println("Valori dei 5 ingressi analogici");
  // Start the I2C Bus as Master
  Wire.begin(8); 
  TWBR = 32; // http://www.gammon.com.au/i2c setto I2C a 200 KHz


} // *********** fine ciclo Setup **********


// ************* inizio ciclo Loop ************
void loop() {

// MCP41010Write(ValMasterVolume); // comando del pot digitale

  // lettura input analogici econdizionamento dei valori 1023=40 punti della barra VU
  ValAudio_1 = analogRead(Audio_1)/26; 
  ValAudio_2 = analogRead(Audio_2)/26; 
  ValAudio_3 = analogRead(Audio_3)/26; 
  ValAudio_4 = analogRead(Audio_4)/26; 
  ValAudio_5 = analogRead(Audio_5)/26; 

  // trasmissione a console i2c ID 9 dei livelli audio in ingresso
  Wire.beginTransmission(9); 
  Wire.write(ValAudio_1);   
  Wire.write(ValAudio_2);  
  Wire.write(ValAudio_3);   
  Wire.write(ValAudio_4);    
  Wire.write(ValAudio_5);    
  Wire.endTransmission(); 
  
delay(200); // aggiunta
    
  // ricezione dello stato degli interruttori Mute della console
  Wire.onReceive(receiveEvent); 
  
  // delay(10); // ex 500 TOLTO
  
  // attivazione dei relè di Mute
  command_Mute_On(); 
/*
  // stampa su monitor seriale dei valori attuali
  Serial.println("Valori dei 5 ingressi analogici");
  Serial.println(ValAudio_1);
  Serial.println(ValAudio_2);
  Serial.println(ValAudio_3);
  Serial.println(ValAudio_4);
  Serial.println(ValAudio_5);

  // stampa su monitor seriale dei valori attuali
  Serial.println("Valori dei 5 ingressi digitali");
  Serial.println(Audio_1_Mute_On);
  Serial.println(Audio_2_Mute_On);
  Serial.println(Audio_3_Mute_On);
  Serial.println(Audio_4_Mute_On);
  Serial.println(Audio_5_Mute_On);
*/
  Serial.println("Valore del potenziometro");
  Serial.println(ValMasterVolume);
  //Serial.println("MUTE All");
  //Serial.println(Audio_Mute_All);
  
// delay(1000);

MCP41010Write(ValMasterVolume); // comando del pot digitale


} // ********** fine ciclo Loop *************

// *********** Funzioni di servizio *********
// --------------------------------------------
void receiveEvent(int bytes) {

  // ricezione dello stato degli interruttori Mute della console e del potenziometro
  Audio_1_Mute_On = Wire.read();      
  Audio_2_Mute_On = Wire.read();    
  Audio_3_Mute_On = Wire.read();      
  Audio_4_Mute_On = Wire.read();    
  Audio_5_Mute_On = Wire.read();   
  Audio_Mute_All = Wire.read(); 
  ValMasterVolume = Wire.read();

  //delay(10); // ex 500 TOLTO
  
} // fine funzione
// --------------------------------------------
void command_Mute_On() {

if (Audio_Mute_All==0) {  

  digitalWrite(Audio_1_Mute, HIGH); 
  digitalWrite(Audio_2_Mute, HIGH);
  digitalWrite(Audio_3_Mute, HIGH);
  digitalWrite(Audio_4_Mute, HIGH);
  digitalWrite(Audio_5_Mute, HIGH);

}
else
{

if (Audio_1_Mute_On==0) {  
  digitalWrite(Audio_1_Mute, HIGH); 
}
else
{
  digitalWrite(Audio_1_Mute, LOW);
} 


if (Audio_2_Mute_On==0) {  
  digitalWrite(Audio_2_Mute, HIGH);   
}
else
{
  digitalWrite(Audio_2_Mute, LOW);
} 

if (Audio_3_Mute_On==0) {  
  digitalWrite(Audio_3_Mute, HIGH);   
}
else
{
  digitalWrite(Audio_3_Mute, LOW);
} 

if (Audio_4_Mute_On==0) {  
  digitalWrite(Audio_4_Mute, HIGH);   
}
else
{
  digitalWrite(Audio_4_Mute, LOW);
} 

if (Audio_5_Mute_On==0) {  
  digitalWrite(Audio_5_Mute, HIGH);   
}
else
{
  digitalWrite(Audio_5_Mute, LOW);
} 

}

} // fine funzione

// --------------------------------------------

void MCP41010Write(byte value) 
{
   
  digitalWrite(CS,LOW);
  SPI.transfer(B00010001); // This tells the chip to set the pot
  SPI.transfer(value);     // This tells it the pot position
  digitalWrite(CS,HIGH); 
}

// }
